/* -*- C++ -*-
 * Copyright ©2005 Hugo Mills <hugo@carfax.org.uk>
 *
 * This software is distributed under the terms of the GNU GPL v2
 * For more information on the GPL, see the file COPYING or 
 * visit http://www.gnu.org/
 *
 * This software is distributed without warranty
 */

#ifndef CONTENTGROUP_H
#define CONTENTGROUP_H

#include <list>

#include "magellan/configlexer.h"
#include "magellan/content.h"
#include "magellan/plugininfo_content.h"

class ContentGroup : public Content
{
public:
	ContentGroup() { }
	virtual ~ContentGroup();

	virtual void plot(
		Output* bitmap,
		XfView* viewport,
		XfMap* projection,
		XfOrbit* orbit,
		XfSphere* sphere
		);

	static Content* parse(
		ConfigLexer* lex,
		const std::string& type,
		const std::string& subtype
		);

	static PluginInfo* getmodules(int i);
	static void set_content_plugins(std::list<PluginInfo_Content*>* cp)
	{ content_plugins = cp; }

	virtual Plugin* bind(Configuration*);
	virtual bool isbound() const;

private:
	void add(Content*);
	std::list<Content*> contents;
	static std::list<PluginInfo_Content*>* content_plugins;
};

#endif
