/* -*- C++ -*-
 * Copyright ©2004 Hugo Mills <hugo@carfax.org.uk>
 *
 * This software is distributed under the terms of the GNU GPL v2
 * For more information on the GPL, see the file COPYING or 
 * visit http://www.gnu.org/
 *
 * This software is distributed without warranty
 */

#ifndef VECTORS_H
#define VECTORS_H

#include <valarray>

//typedef std::valarray<double> dvec;
//typedef std::valarray<int> ivec;

template<class T, int L>
class _vec : public std::valarray<T>
{
public:
	_vec() : std::valarray<T>(L) { }
	_vec(const T& v) : std::valarray<T>(v, L) { }
	_vec(const std::valarray<T>& v) : std::valarray<T>(v) { }
	virtual ~_vec() { }
};

typedef _vec<double, 2> dvec2;
typedef _vec<double, 3> dvec3;
typedef _vec<int, 2> ivec2;
typedef _vec<int, 3> ivec3;

typedef _vec<double, 9> dmat3;

#endif
