/* -*- C++ -*-
 * Copyright ©2004 Hugo Mills <hugo@carfax.org.uk>
 *
 * This software is distributed under the terms of the GNU GPL v2
 * For more information on the GPL, see the file COPYING or 
 * visit http://www.gnu.org/
 *
 * This software is distributed without warranty
 */

// Transformation to convert between globe coordinates and map space
// (i.e. the main projection function)
// f() should throw an exception if the point is not visible in this projection
// f_edge() can be used to find a map point on the edge between
// visible (first parameter) and invisible (second parameter)
// g() should throw an exception if the point is not on the projected surface

#ifndef XFMAP_H
#define XFMAP_H

#include "magellan/vectors.h"
#include "magellan/plugin.h"

// The plugininfo
class XfMap;
#include "magellan/plugininfo_map.h"

// Useful tools
#include "magellan/configlexer.h"
#include "magellan/parsertools.h"
#include "magellan/values.h"

/*
class NotVisible { };
class NotProjected { };

typedef enum {
	MapRV_VISIBLE, // Edge is fully visible
	MapRV_NOTVISIBLE, // Edge is fully invisible
	MapRV_LEAVING, // Edge leaves projection region
	MapRV_ENTERING, // Edge enters projection region
	MapRV_REENTERING, // Edge leaves region and enters it again
	MapRV_RELEAVING // Edge enters region and leaves it again
} MapRV;

class OutlPt;

class EdgeCrossing
{
public:
	dvec2 map_pos;
	OutlPt* end;
	virtual bool operator<(const EdgeCrossing&) = 0;
};
*/

class XfMap : public Plugin
{
 public:
	XfMap() { }

	// Forward: map a 3-vec on the globe to a 2-vec on the map
	virtual bool f(dvec2&, const dvec3&) const = 0;
	// Backward: map a 2-vec on the map to a 3-vec on the globe
	virtual bool g(dvec3&, const dvec2&) const = 0;

	// Functions for handling edges of the projection
/*
	virtual MapRV edge_test(const dvec3&, const dvec3&) const
	{ return MapRV_VISIBLE; }
	virtual EdgeCrossing* f_edge(const dvec& a, const dvec& b) const
	{ return NULL; }
	virtual std::pair<EdgeCrossing*, EdgeCrossing*>
	f_edge2(const dvec& a, const dvec& b) const 
	{ return std::pair<EdgeCrossing*, EdgeCrossing*>(NULL, NULL); }
*/

protected:
	virtual ~XfMap() { }
};

#endif
