/* -*- C++ -*-
 * Copyright ©2004 Hugo Mills <hugo@carfax.org.uk>
 *
 * This software is distributed under the terms of the GNU GPL v2
 * For more information on the GPL, see the file COPYING or 
 * visit http://www.gnu.org/
 *
 * This software is distributed without warranty
 */

#include <cmath>
#include <fstream>
#include <iostream>

#include "magellan/configuration.h"
#include "magellan/options.h"
#include "plugins.h"

int main(int argc, char* argv[])
{
	opts = new Options(argc, argv);

	load_plugins();

	ConfigLexer* lex = new ConfigLexer(opts->configfile());
	Configuration* config = new Configuration(lex);
	delete lex;

	do {
		config->update();
		config->render();
		config->output();
		if(config->repeated())
			sleep(config->updatetime());
	} while(config->repeated());

	unload_plugins();

	delete config;
	delete opts;

	return EXIT_SUCCESS;
}
