/* -*- C++ -*-
 * Copyright ©2005 Hugo Mills <hugo@carfax.org.uk>
 *
 * This software is distributed under the terms of the GNU GPL v2
 * For more information on the GPL, see the file COPYING or 
 * visit http://www.gnu.org/
 *
 * This software is distributed without warranty
 */

#ifndef COORDINATE_H
#define COORDINATE_H

#include <list>
#include <iostream>

class Coordinate
{ 
public: 
	Coordinate(double _x, double _y) : x(_x), y(_y) { }
	double x, y;
};
class iCoordinate
{
public:
	iCoordinate(int _x, int _y) : x(_x), y(_y) { }
	int x, y;
	bool operator==(const iCoordinate& i) const
	{ return x == i.x && y == i.y; }
};

class Contour : public std::list<Coordinate> { };
class Trace : public std::list<Contour> { };

std::ostream& operator<<(std::ostream& o, const iCoordinate& c);
std::ostream& operator<<(std::ostream& o, const Coordinate& c);

#endif
