/* -*- C++ -*-
 * Copyright ©2005 Hugo Mills <hugo@carfax.org.uk>
 *
 * This software is distributed under the terms of the GNU GPL v2
 * For more information on the GPL, see the file COPYING or 
 * visit http://www.gnu.org/
 *
 * This software is distributed without warranty
 */

#include "magellan/plugin.h"

#include "magellan/configuration.h"

Plugin::~Plugin()
{
	if(_refs > 0)
		std::cerr << "BUG: plugin object at " << this << " deleted with remaining references." << std::endl;
}

bool Plugin::destroy(void)
{
	_refs--;
	bool killme = (_refs == 0);
	if(killme)
		delete this;
	return killme;
}

Plugin* Plugin::bind(Configuration* conf)
{
	return this;
}
