/* -*- C++ -*-
 * Copyright ©2004 Hugo Mills <hugo@carfax.org.uk>
 *
 * This software is distributed under the terms of the GNU GPL v2
 * For more information on the GPL, see the file COPYING or 
 * visit http://www.gnu.org/
 *
 * This software is distributed without warranty
 */

#ifndef CONTENT_CHECK_H
#define CONTENT_CHECK_H

#include "magellan/content.h"

class Content_Check : public Content
{
public:
	Content_Check(
		int hd, int vd,
		const ivec3& c1,
		const ivec3& c2
		) 
		: hdivs(hd),
		  vdivs(vd),
		  colour1(c1),
		  colour2(c2)
	{ }
	virtual ~Content_Check() { }

	virtual void plot(
		Output* bm,
		XfView* vp,
		XfMap* proj,
		XfOrbit* orb,
		XfSphere* sph
		);

	static Content* parse(
		ConfigLexer* lex,
		const std::string& type,
		const std::string& subtype = ""
		);

private:
	ivec3 colour1;
	ivec3 colour2;
	int hdivs;
	int vdivs;
};

#endif
