/* -*- C++ -*-
 * Copyright ©2004 Hugo Mills <hugo@carfax.org.uk>
 *
 * This software is distributed under the terms of the GNU GPL v2
 * For more information on the GPL, see the file COPYING or 
 * visit http://www.gnu.org/
 *
 * This software is distributed without warranty
 */

#ifndef CONTENT_LATLONGMARKS_H
#define CONTENT_LATLONGMARKS_H

#include "magellan/content.h"

class Content_LatLongMarks : public Content
{
public:
	Content_LatLongMarks(
		double lomj, double lomn,
		double lamj, double lamn,
		bool sc, const ivec3& col
		)
		: lonmajors(lomj), lonminors(lomn),
		  latmajors(lamj), latminors(lamn),
		  scale(sc), colour(col)
	{ }

	virtual ~Content_LatLongMarks() { }

	virtual void plot(
		Output* bitmap,
		XfView* viewport,
		XfMap* projection,
		XfOrbit* orbit,
		XfSphere* sphere
		);

	static Content* parse(
		ConfigLexer* lex,
		const std::string& type,
		const std::string& subtype
		);

private:
	double lonmajors, lonminors;
	double latmajors, latminors;
	bool scale;
	ivec3 colour;
};

#endif
