/* -*- c++ -*-
 * Copyright ©2008 Hugo Mills <hugo@carfax.org.uk>
 *
 * This software is distributed under the terms of the GNU GPL v2
 * For more information on the GPL, see the file COPYING or 
 * visit http://www.gnu.org/
 *
 * This software is distributed without warranty
 */

#ifndef CONTENT_LOXODROME_H
#define CONTENT_LOXODROME_H

#include "magellan/content.h"

class Content_Loxodrome : public Content
{
public:
	Content_Loxodrome(
		double lo0, double la0,
		double lo1, double la1,
		int l, bool s,
		const ivec3& col
		);
	virtual ~Content_Loxodrome() { }

	virtual void plot(
		Output* bitmap,
		XfView* viewport,
		XfMap* projection,
		XfOrbit* orbit,
		XfSphere* sphere
		);

	static Content* parse(
		ConfigLexer* lex,
		const std::string& type,
		const std::string& subtype
		);

private:
	double lon0; // Longitude offset
	double lons; // Longitude scaling
	double k;    // "Slope"
	double C;    // "Offset"
	bool solid;
	ivec3 colour;
};

#endif
