/* -*- C++ -*-
 * Copyright ©2004 Hugo Mills <hugo@carfax.org.uk>
 *
 * This software is distributed under the terms of the GNU GPL v2
 * For more information on the GPL, see the file COPYING or 
 * visit http://www.gnu.org/
 *
 * This software is distributed without warranty
 */

#ifndef XFMAP_CYLORTHOGRAPHIC_H
#define XFMAP_CYLORTHOGRAPHIC_H

#include "magellan/xfmap.h"

class XfMap_CylindricalOrthographic : public XfMap
{
 public:
	XfMap_CylindricalOrthographic(double std)
		: stdparallel(std),
		  scale(cos(std))
	{ }
	virtual ~XfMap_CylindricalOrthographic() { }

	virtual bool f(dvec2&, const dvec3&) const;
	virtual bool g(dvec3&, const dvec2&) const;

	static XfMap* parser(
		ConfigLexer* lex,
		const std::string& type,
		const std::string& subtype = ""
		);

private:
	double stdparallel;
	double scale;
};

#endif
