/* -*- C++ -*-
 * Copyright ©2004 Hugo Mills <hugo@carfax.org.uk>
 *
 * This software is distributed under the terms of the GNU GPL v2
 * For more information on the GPL, see the file COPYING or 
 * visit http://www.gnu.org/
 *
 * This software is distributed without warranty
 */

#ifndef XFMAP_PLANAREQUIDISTANT_H
#define XFMAP_PLANAREQUIDISTANT_H

#include "magellan/xfmap.h"

class XfMap_PlanarEquidistant : public XfMap
{
 public:
	XfMap_PlanarEquidistant(double lim)
		: limit(lim)
	{ }
	virtual ~XfMap_PlanarEquidistant() { }

	virtual bool f(dvec2&, const dvec3&) const;
	virtual bool g(dvec3&, const dvec2&) const;

	static XfMap* parser(
		ConfigLexer* lex,
		const std::string& type,
		const std::string& subtype = ""
		);

private:
	double limit;
};

#endif
