/* -*- C++ -*-
 * Copyright ©2004 Hugo Mills <hugo@carfax.org.uk>
 *
 * This software is distributed under the terms of the GNU GPL v2
 * For more information on the GPL, see the file COPYING or 
 * visit http://www.gnu.org/
 *
 * This software is distributed without warranty
 */

#ifndef XFORBIT_CIRCULAR_H
#define XFORBIT_CIRCULAR_H

#include "magellan/xforbit.h"

class XfOrbit_Circular : public XfOrbit
{
public:
	XfOrbit_Circular(double _nodes,
					 double _angle,
					 long _period,
					 long _timeorigin,
					 double _precession,
					 bool _upright);
	virtual ~XfOrbit_Circular() { }

	virtual void reset(void);

	static XfOrbit* parser(
		ConfigLexer* lex,
		const std::string& type,
		const std::string& subtype = ""
		);

private:
	double nodes, angle, precession;
	long period, timeorigin;
	bool upright;
};

#endif
